package com.example.duonachi.activity;

import android.app.AlertDialog;
import android.content.Intent;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;

import androidx.appcompat.app.AppCompatActivity;

import com.example.duonachi.R;

import java.util.Random;

public class Eatwhat extends AppCompatActivity {

    private Button BackButton;
    private Button StartButton;
    private Button SelfDefineButton;
    private TextView textView;
    private String[] dishes = {"江南里", "越香小笼", "螺蛳粉", "食堂", "牛奶棚"};
    private int old_index = -1;


    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_eatwhat);

        textView = findViewById(R.id.textView0);
        //首页按钮
        BackButton = findViewById(R.id.BackButton);
        BackButton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                Intent intent = new Intent(Eatwhat.this, Mainpage .class);
                startActivity(intent);
            }
        });
        //开始随机生成按钮
        StartButton = findViewById(R.id.StartButton);
        StartButton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                int randomIndex = new Random().nextInt(dishes.length);
                while(randomIndex == old_index)
                    randomIndex = new Random().nextInt(dishes.length);
                old_index = randomIndex;
                String randomWord = dishes[randomIndex];
                textView.setText(randomWord);
            }
        });

        SelfDefineButton = findViewById(R.id.SelfDefineButton);
        SelfDefineButton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                    // 创建一个自定义的对话框
                   AlertDialog.Builder builder = new AlertDialog.Builder(Eatwhat.this);
                   builder.setTitle("编辑菜肴列表,菜肴之间用空格分隔");

                   // 创建一个自定义的布局，用于显示输入框和确认按钮
                   LayoutInflater inflater = getLayoutInflater();
                   View viewGroup = inflater.inflate(R.layout.eatwhat_dialog, null);
                   builder.setView(viewGroup);

                   // 获取输入框和确认按钮的引用,设置文本
                   EditText editText = viewGroup.findViewById(R.id.edit_text);
                   Button confirmButton = viewGroup.findViewById(R.id.confirm_button);
                   editText.setText(make_string(dishes));

                   // 创建并显示对话框
                   AlertDialog dialog = builder.create();
                   dialog.show();
                   //设置确认按钮的监听
                   confirmButton.setOnClickListener(new View.OnClickListener() {
                        @Override
                        public void onClick(View view) {
                            // 重设自定义的dishes
                            String new_dishes = String.valueOf(editText.getText());
                            dishes = get_dishes(new_dishes);
                            dialog.dismiss();
                        }
                    });
                }
            });
    }
    protected String make_string(String s[])//处理自定义菜输出
    {
        int len = s.length;
        String outcome = "";
        for(int i = 0;i<len;i++)
        {
            outcome += s[i] +' ';
        }
        return outcome;
    }

    protected String[] get_dishes(String s)//处理自定义菜写入
    {
        String[] splitText = s.split(" ");
        return splitText;
    }
}