package com.example.duonachi.activity;

import android.content.Intent;
import android.net.Uri;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.TextView;

import androidx.appcompat.app.AppCompatActivity;

import com.example.duonachi.R;

import org.json.JSONObject;

import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

public class History extends AppCompatActivity {

    private LinearLayout linearLayout;
    private Button BackButton;
    private TextView textView;
    private ImageView imageView;
    private String[] imageuri_list;
    private String[] results;
    private static HashMap<String,String> history_list = new HashMap<>();

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_history);

        if(history_list != null) {
            divide_history();//将历史记录拆分为uri列表和结果列表
            put_image_and_text();//将图片和结果对应放入imageView和textview
            set_trans_intent();//设置每条历史记录layout的页面跳转
        }

        BackButton = findViewById(R.id.BackButton);
        BackButton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                Intent intent = new Intent(History.this, Mainpage .class);
                startActivity(intent);
            }
        });
    }

    private void set_trans_intent() //设置每条历史记录layout的页面跳转
    {
        for (int i = 0; i < imageuri_list.length; i++) {
            //创建layoutid数组
            int[] linearLayoutIds = new int[]{R.id.linearLayout0,R.id.linearLayout1,R.id.linearLayout2,R.id.linearLayout3};
            //采集对应的图片uri和结果名字
            String imageuri = imageuri_list[i];
            String result = results[i];
            // 获取对应的Layout对象,设置点击事件监听器
            linearLayout = findViewById(linearLayoutIds[i]);
            linearLayout.setOnClickListener(new View.OnClickListener() {
                @Override
                public void onClick(View v) {
                    // 创建Intent
                    Intent intent = new Intent(History.this, IdentifyResult.class);
                    intent.putExtra("figureUri",imageuri);
                    intent.putExtra("result",result);
                    startActivity(intent);
                }
            });
        }
    }

    private void put_image_and_text() //将图片和结果对应放入imageView和textview
    {
        //创建id号数组
        int[] textViewId = new int[]{R.id.textView0,R.id.textView1,R.id.textView2,R.id.textView3};
        int[] imageViewId = new int[]{R.id.imageView0,R.id.imageView1,R.id.imageView2,R.id.imageView3};
        for(int i = 0;i<imageuri_list.length;i++)
        {
            textView = findViewById(textViewId[i]);
            String result = results[i];
            //提取出结果中的名字,处理识别结果idt_result
            try {
                //用org.json包处理结果，结果存在列表
                JSONObject jsonObject = new JSONObject(result);
                String org_result = jsonObject.get("result").toString();
                String deal_result = org_result.substring(1, org_result.length() - 1);//删除列表的[]
                JSONObject resultObject = new JSONObject(deal_result);
                //获取第一层的数据
                String name = resultObject .getString("name");
                textView.setText(name);
            } catch (org.json.JSONException e) {
                e.printStackTrace();
                System.out.println("Invalid JSON string");
            }
            imageView = findViewById(imageViewId[i]);
            imageView.setImageURI(Uri.parse(imageuri_list[i]));
        }
    }

    //修改历史列表
    protected static void chage_history(String Uri,String result)
    {
        history_list.put(Uri,result);
    }

    protected void divide_history()//将历史记录拆分为uri列表和结果列表
    {
        List<Map.Entry<String, String>> lastFourEntries = history_list.entrySet().stream()
                .limit(Math.min(4, history_list.size()))
                .collect(Collectors.toList());
        // 获取key数组(uri)
        imageuri_list = lastFourEntries.stream()
                .map(Map.Entry::getKey)
                .toArray(String[]::new);
        // 获取value数组(result)
        results = lastFourEntries.stream()
                .map(Map.Entry::getValue)
                .toArray(String[]::new);
    }
}