package com.example.duonachi.activity;


import android.content.Intent;
import android.net.Uri;
import android.os.Bundle;
import android.text.method.ScrollingMovementMethod;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.TextView;

import androidx.appcompat.app.AppCompatActivity;

import com.example.duonachi.R;

import org.json.JSONArray;
import org.json.JSONObject;



public class IdentifyResult extends AppCompatActivity {

    private Button BackButton;
    private Button IdentifyAgainButton;
    private Button ChangeResultButton;
    private TextView Result_textView;
    private ImageView result_imageview;
    private String[]  final_results = new String[5];
    private int result_index = 0;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_identify_result);

        //intent获取识别结果
        Intent intent = getIntent();
        String idt_result = intent.getStringExtra("result");
        String ImageUri = intent.getStringExtra("figureUri"); // 使用getStringExtra方法通过键来获取字符串
        Log.d("figureUri2",ImageUri);
        Uri uri = Uri.parse(ImageUri);

        //存入历史记录
        History.chage_history(ImageUri,idt_result);

        //处理识别结果idt_result，生成结果数组final_results
        set_finel_result(idt_result);

        //显示识别用的文本和图片
        Result_textView = findViewById(R.id.Result_textView);
        Result_textView.setText(final_results[result_index]);
        Result_textView.setScrollBarStyle(View.SCROLLBARS_INSIDE_OVERLAY);
        Result_textView.setMovementMethod(new ScrollingMovementMethod());

        result_imageview = findViewById(R.id.result_imageview);
        result_imageview.setImageURI(uri);

        //首页按钮
        BackButton = findViewById(R.id.BackButton);
        BackButton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                Intent intent = new Intent(IdentifyResult.this, Mainpage.class);
                startActivity(intent);
            }
        });

        //再次识别按钮
        IdentifyAgainButton = findViewById(R.id.IdentifyAgainButton);
        IdentifyAgainButton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view)
            {
                Intent intent = new Intent(IdentifyResult.this, Identify.class);
                startActivity(intent);
            }
        });

        //更换结果按钮
        ChangeResultButton = findViewById(R.id.ChangeResultButton);
        ChangeResultButton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                if(final_results[result_index+1] == null)
                {
                    result_index = 0;
                    Result_textView.setText(final_results[result_index]);
                }
                else if(result_index <2) Result_textView.setText(final_results[++result_index]);
                else{
                    result_index = 0;
                    Result_textView.setText(final_results[result_index]);
                }
            }
        });
    }

    //处理识别结果idt_result，生成final_results
    private void set_finel_result(String idt_result) {
        try {
            //用org.json包处理结果，结果存在列表
            JSONObject jsonObject = new JSONObject(idt_result);
            JSONArray resultArray = jsonObject.getJSONArray("result"); // 获取result数组
            for (int i = 0; i < resultArray.length(); i++) { // 遍历数组中的每一个元素
                JSONObject resultObject = resultArray.getJSONObject(i); // 获取每一个元素（即一个JSONObject）
                // 获取第一层的数据：名称，卡路里，置信度
                String name = resultObject .getString("name");
                if(name.equals("非菜")) //处理非菜结果
                {
                    final_results[0] = name;
                    break;
                }
                String calorie = resultObject.getString("calorie");
                String probability = resultObject.getString("probability");
                //获取第二层的数据：描述
                JSONObject baike_infoObject = resultObject.getJSONObject("baike_info");
                String description = baike_infoObject .getString("description");

                String final_result = "菜品名称：" + name + "\n卡路里：" + calorie +"\n可信度：" + probability + "\n菜品描述：" + description;
                final_results[i] = final_result;
            }
        } catch (org.json.JSONException e) {
            e.printStackTrace();
            System.out.println("Invalid JSON string");
        }
    }
}